'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Code = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = function (props) {
  return _react2.default.createElement(
    _styledComponents.ThemeProvider,
    { theme: emptyTheme },
    _react2.default.createElement(CodeWithTheme, props)
  );
};

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _prismAsyncLight = require('react-syntax-highlighter/prism-async-light');

var _prismAsyncLight2 = _interopRequireDefault(_prismAsyncLight);

var _styledComponents = require('styled-components');

var _supportedLanguages = require('./supportedLanguages');

var _themeBuilder = require('./themes/themeBuilder');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Code = exports.Code = function (_PureComponent) {
  (0, _inherits3.default)(Code, _PureComponent);

  function Code() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Code);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Code.__proto__ || (0, _getPrototypeOf2.default)(Code)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      language: (0, _supportedLanguages.normalizeLanguage)('')
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Code, [{
    key: 'registerLanguage',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(language) {
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (_prismAsyncLight2.default.astGenerator) {
                  _context.next = 3;
                  break;
                }

                _context.next = 3;
                return _prismAsyncLight2.default.astGeneratorPromise;

              case 3:
                if (!_prismAsyncLight2.default.astGenerator.registered(language)) {
                  _context.next = 5;
                  break;
                }

                return _context.abrupt('return', this.setState({ language: language }));

              case 5:
                if (_supportedLanguages.languageLoaders[language]) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt('return', undefined);

              case 7:
                _context.next = 9;
                return _supportedLanguages.languageLoaders[language]();

              case 9:
                return _context.abrupt('return', this.setState({ language: language }));

              case 10:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function registerLanguage(_x) {
        return _ref2.apply(this, arguments);
      }

      return registerLanguage;
    }()
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var language = (0, _supportedLanguages.normalizeLanguage)(this.props.language);
      this.registerLanguage(language);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(_ref3) {
      var prevLanguage = _ref3.language;

      var language = (0, _supportedLanguages.normalizeLanguage)(this.props.language);

      if (prevLanguage !== language) {
        this.registerLanguage(language);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _applyTheme = (0, _themeBuilder.applyTheme)(this.props.theme),
          inlineCodeStyle = _applyTheme.inlineCodeStyle;

      var props = {
        language: this.state.language,
        PreTag: 'span',
        style: this.props.codeStyle || inlineCodeStyle,
        showLineNumbers: this.props.showLineNumbers,
        lineNumberContainerStyle: this.props.lineNumberContainerStyle,
        codeTagProps: this.props.codeTagProps
      };

      return _react2.default.createElement(
        _prismAsyncLight2.default,
        props,
        this.props.text
      );
    }
  }]);
  return Code;
}(_react.PureComponent);

Code.defaultProps = {
  language: '',
  theme: {},
  showLineNumbers: false,
  lineNumberContainerStyle: null,
  codeTagProps: {}
};


var CodeWithTheme = (0, _styledComponents.withTheme)(Code);
var emptyTheme = {};