'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.normalizeLanguage = exports.SUPPORTED_LANGUAGES = exports.languageLoaders = undefined;

var _freeze = require('babel-runtime/core-js/object/freeze');

var _freeze2 = _interopRequireDefault(_freeze);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _prismAsyncLight = require('react-syntax-highlighter/prism-async-light');

var _prismAsyncLight2 = _interopRequireDefault(_prismAsyncLight);

var _memoizeOne = require('memoize-one');

var _memoizeOne2 = _interopRequireDefault(_memoizeOne);

var _markup = require('react-syntax-highlighter/languages/prism/markup');

var _markup2 = _interopRequireDefault(_markup);

var _markupTemplating = require('react-syntax-highlighter/languages/prism/markup-templating');

var _markupTemplating2 = _interopRequireDefault(_markupTemplating);

var _clike = require('react-syntax-highlighter/languages/prism/clike');

var _clike2 = _interopRequireDefault(_clike);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
  Markup, markup-templating & clike are base languages required to get the others to work.
  Technically we could probably also async load those, but for simplicity sake we're just always loading them.
*/
_prismAsyncLight2.default.registerLanguage('markup', _markup2.default);

/*
 * Only load the base languages required to get other languages to work.
 */

/* eslint import/no-dynamic-require: 0, global-require: 0 */

_prismAsyncLight2.default.registerLanguage('markup-templating', _markupTemplating2.default);
_prismAsyncLight2.default.registerLanguage('clike', _clike2.default);

var createAsyncLanguageLoader = function createAsyncLanguageLoader(name, loader) {
  return (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
    var _ref2, language;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return loader();

          case 2:
            _ref2 = _context.sent;
            language = _ref2.default;

            _prismAsyncLight2.default.registerLanguage(name, language);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));
};

var languageLoaders = exports.languageLoaders = {
  coffeescript: createAsyncLanguageLoader('cofeescript', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_coffeescript" */'react-syntax-highlighter/languages/prism/coffeescript');
  }),
  cpp: createAsyncLanguageLoader('cpp', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_cpp" */'react-syntax-highlighter/languages/prism/cpp');
  }),
  csharp: createAsyncLanguageLoader('csharp', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_csharp" */'react-syntax-highlighter/languages/prism/csharp');
  }),
  css: createAsyncLanguageLoader('css', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_css" */'react-syntax-highlighter/languages/prism/css');
  }),
  d: createAsyncLanguageLoader('d', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_d" */'react-syntax-highlighter/languages/prism/d');
  }),
  go: createAsyncLanguageLoader('go', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_go" */'react-syntax-highlighter/languages/prism/go');
  }),
  groovy: createAsyncLanguageLoader('groovy', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_groovy" */'react-syntax-highlighter/languages/prism/groovy');
  }),
  java: createAsyncLanguageLoader('java', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_java" */'react-syntax-highlighter/languages/prism/java');
  }),
  javascript: createAsyncLanguageLoader('javascript', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_javascript" */'react-syntax-highlighter/languages/prism/javascript');
  }),
  kotlin: createAsyncLanguageLoader('kotlin', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_kotlin" */'react-syntax-highlighter/languages/prism/kotlin');
  }),
  lua: createAsyncLanguageLoader('lua', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_lua" */'react-syntax-highlighter/languages/prism/lua');
  }),
  objectivec: createAsyncLanguageLoader('objectivec', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_objectivec" */'react-syntax-highlighter/languages/prism/objectivec');
  }),
  php: createAsyncLanguageLoader('php', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_php" */'react-syntax-highlighter/languages/prism/php');
  }),
  python: createAsyncLanguageLoader('python', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_python" */'react-syntax-highlighter/languages/prism/python');
  }),
  ruby: createAsyncLanguageLoader('ruby', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_ruby" */'react-syntax-highlighter/languages/prism/ruby');
  }),
  rust: createAsyncLanguageLoader('rust', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_rust" */'react-syntax-highlighter/languages/prism/rust');
  }),
  scala: createAsyncLanguageLoader('scala', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_scala" */'react-syntax-highlighter/languages/prism/scala');
  }),
  shell: createAsyncLanguageLoader('shell', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_bash" */'react-syntax-highlighter/languages/prism/bash');
  }),
  sql: createAsyncLanguageLoader('sql', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_sql" */'react-syntax-highlighter/languages/prism/sql');
  }),
  swift: createAsyncLanguageLoader('swift', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_swift" */'react-syntax-highlighter/languages/prism/swift');
  }),
  typescript: createAsyncLanguageLoader('typescript', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_typescript" */'react-syntax-highlighter/languages/prism/typescript');
  }),
  yaml: createAsyncLanguageLoader('yaml', function () {
    return import( /* webpackChunkName: "react-syntax-highlighter_languages_prism_yaml" */'react-syntax-highlighter/languages/prism/yaml');
  })
};

/*
 * These values all those are supported by ADF.
 * The comments show mappings of these values to the corresponding
 * language definition file, or to that of the most
 * syntactically similar language supported by highlightjs
 */
var SUPPORTED_LANGUAGES = exports.SUPPORTED_LANGUAGES = (0, _freeze2.default)([{
  name: 'PHP',
  alias: ['php', 'php3', 'php4', 'php5'],
  value: 'php'
}, {
  name: 'Java',
  alias: ['java'],
  value: 'java'
}, {
  name: 'CSharp',
  alias: ['csharp', 'c#'],
  value: 'cs'
}, {
  name: 'Python',
  alias: ['python', 'py'],
  value: 'python'
}, {
  name: 'JavaScript',
  alias: ['javascript', 'js'],
  value: 'javascript'
}, {
  name: 'Html',
  alias: ['html'],
  value: 'xml'
}, {
  name: 'C++',
  alias: ['c++', 'cpp', 'clike'],
  value: 'cpp'
}, {
  name: 'Ruby',
  alias: ['ruby', 'rb', 'duby'],
  value: 'ruby'
}, {
  name: 'Objective-C',
  alias: ['objective-c', 'objectivec', 'obj-c', 'objc'],
  value: 'objectivec'
}, {
  name: 'C',
  alias: ['c'],
  value: 'cpp'
}, {
  name: 'Swift',
  alias: ['swift'],
  value: 'swift'
}, {
  name: 'TeX',
  alias: ['tex', 'latex'],
  value: 'tex'
}, {
  name: 'Shell',
  alias: ['shell', 'bash', 'sh', 'ksh', 'zsh'],
  value: 'shell'
}, {
  name: 'Scala',
  alias: ['scala'],
  value: 'scala'
}, {
  name: 'Go',
  alias: ['go'],
  value: 'go'
}, {
  name: 'ActionScript',
  alias: ['actionscript', 'actionscript3', 'as'],
  value: 'actionscript'
}, {
  name: 'ColdFusion',
  alias: ['coldfusion'],
  value: 'xml'
}, {
  name: 'JavaFX',
  alias: ['javafx', 'jfx'],
  value: 'java'
}, {
  name: 'VbNet',
  alias: ['vbnet', 'vb.net'],
  value: 'vbnet'
}, {
  name: 'JSON',
  alias: ['json'],
  value: 'json'
}, {
  name: 'MATLAB',
  alias: ['matlab'],
  value: 'matlab'
}, {
  name: 'Groovy',
  alias: ['groovy'],
  value: 'groovy'
}, {
  name: 'SQL',
  alias: ['sql', 'postgresql', 'postgres', 'plpgsql', 'psql', 'postgresql-console', 'postgres-console', 'tsql', 't-sql', 'mysql', 'sqlite'],
  value: 'sql'
}, {
  name: 'R',
  alias: ['r'],
  value: 'r'
}, {
  name: 'Perl',
  alias: ['perl', 'pl'],
  value: 'perl'
}, {
  name: 'Lua',
  alias: ['lua'],
  value: 'lua'
}, {
  name: 'Delphi',
  alias: ['delphi', 'pas', 'pascal', 'objectpascal'],
  value: 'delphi'
}, {
  name: 'XML',
  alias: ['xml'],
  value: 'xml'
}, {
  name: 'TypeScript',
  alias: ['typescript', 'ts'],
  value: 'typescript'
}, {
  name: 'CoffeeScript',
  alias: ['coffeescript', 'coffee-script', 'coffee'],
  value: 'coffeescript'
}, {
  name: 'Haskell',
  alias: ['haskell', 'hs'],
  value: 'haskell'
}, {
  name: 'Puppet',
  alias: ['puppet'],
  value: 'puppet'
}, {
  name: 'Arduino',
  alias: ['arduino'],
  value: 'arduino'
}, {
  name: 'Fortran',
  alias: ['fortran'],
  value: 'fortran'
}, {
  name: 'Erlang',
  alias: ['erlang', 'erl'],
  value: 'erlang'
}, {
  name: 'PowerShell',
  alias: ['powershell', 'posh', 'ps1', 'psm1'],
  value: 'powershell'
}, {
  name: 'Haxe',
  alias: ['haxe', 'hx', 'hxsl'],
  value: 'haxe'
}, {
  name: 'Elixir',
  alias: ['elixir', 'ex', 'exs'],
  value: 'elixir'
}, {
  name: 'Verilog',
  alias: ['verilog', 'v'],
  value: 'verilog'
}, {
  name: 'Rust',
  alias: ['rust'],
  value: 'rust'
}, {
  name: 'VHDL',
  alias: ['vhdl'],
  value: 'vhdl'
}, {
  name: 'Sass',
  alias: ['sass'],
  value: 'less'
}, {
  name: 'OCaml',
  alias: ['ocaml'],
  value: 'ocaml'
}, {
  name: 'Dart',
  alias: ['dart'],
  value: 'dart'
}, {
  name: 'CSS',
  alias: ['css'],
  value: 'css'
}, {
  name: 'reStructuredText',
  alias: ['restructuredtext', 'rst', 'rest'],
  value: 'rest'
}, {
  name: 'ObjectPascal',
  alias: ['objectpascal'],
  value: 'delphi'
}, {
  name: 'Kotlin',
  alias: ['kotlin'],
  value: 'kotlin'
}, {
  name: 'D',
  alias: ['d'],
  value: 'd'
}, {
  name: 'Octave',
  alias: ['octave'],
  value: 'matlab'
}, {
  name: 'QML',
  alias: ['qbs', 'qml'],
  value: 'qml'
}, {
  name: 'Prolog',
  alias: ['prolog'],
  value: 'prolog'
}, {
  name: 'FoxPro',
  alias: ['foxpro', 'vfp', 'clipper', 'xbase'],
  value: 'vbnet'
}, {
  name: 'Scheme',
  alias: ['scheme', 'scm'],
  value: 'scheme'
}, {
  name: 'CUDA',
  alias: ['cuda', 'cu'],
  value: 'cpp'
}, {
  name: 'Julia',
  alias: ['julia', 'jl'],
  value: 'julia'
}, {
  name: 'Racket',
  alias: ['racket', 'rkt'],
  value: 'lisp'
}, {
  name: 'Ada',
  alias: ['ada', 'ada95', 'ada2005'],
  value: 'ada'
}, {
  name: 'Tcl',
  alias: ['tcl'],
  value: 'tcl'
}, {
  name: 'Mathematica',
  alias: ['mathematica', 'mma', 'nb'],
  value: 'mathematica'
}, {
  name: 'Autoit',
  alias: ['autoit'],
  value: 'autoit'
}, {
  name: 'StandardML',
  alias: ['standardmL', 'sml', 'standardml'],
  value: 'sml'
}, {
  name: 'Objective-J',
  alias: ['objective-j', 'objectivej', 'obj-j', 'objj'],
  value: 'objectivec'
}, {
  name: 'Smalltalk',
  alias: ['smalltalk', 'squeak', 'st'],
  value: 'smalltalk'
}, {
  name: 'Vala',
  alias: ['vala', 'vapi'],
  value: 'vala'
}, {
  name: 'ABAP',
  alias: ['abap'],
  value: 'sql'
}, {
  name: 'LiveScript',
  alias: ['livescript', 'live-script'],
  value: 'livescript'
}, {
  name: 'XQuery',
  alias: ['xquery', 'xqy', 'xq', 'xql', 'xqm'],
  value: 'xquery'
}, {
  name: 'PlainText',
  alias: ['text', 'plaintext'],
  value: 'text'
}, {
  name: 'Yaml',
  alias: ['yaml', 'yml'],
  value: 'yaml'
}]);

var normalizeLanguage = exports.normalizeLanguage = (0, _memoizeOne2.default)(function (language) {
  if (!language) {
    return '';
  }
  var match = SUPPORTED_LANGUAGES.find(function (val) {
    return val.name === language || val.alias.includes(language);
  });
  // Fallback to plain monospaced text if language passed but not supported
  return match ? match.value : 'text';
});